#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "Odds2_Profit.h"
#include "FileEncrypt.h"
std::auto_ptr<Odds2_Profit> Odds2_Profit::msSingleton(nullptr);

int Odds2_Profit::GetCount()
{
	return (int)mMapData.size();
}

const Odds2_ProfitData* Odds2_Profit::GetData(int Profit)
{
	auto it = mMapData.find(Profit);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, Odds2_ProfitData>& Odds2_Profit::GetMapData()
{
	return mMapData;
}

void Odds2_Profit::Reload()
{
	mMapData.clear();
	Load();
}

void Odds2_Profit::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Odds2_ProfitData data;
		data.mProfit = element->IntAttribute("Profit");
		data.mRandLower = element->IntAttribute("RandLower");
		data.mRandUpper = element->IntAttribute("RandUpper");
		if (mMapData.find(data.mProfit) != mMapData.end())std::cout <<"data refind:" << data.mProfit << std::endl;
		assert(mMapData.find(data.mProfit) == mMapData.end());
		mMapData.insert(std::make_pair(data.mProfit, data));
		element = element->NextSiblingElement();
	}
}

void Odds2_Profit::Load()
{
	Load("../Config/Odds2_Profit.xml");
}

Odds2_Profit* Odds2_Profit::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Odds2_Profit());
	}
	return msSingleton.get();
}
